    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------
    028     * TickUnit.java
    029     * -------------
    030     * (C) Copyright 2001-2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: TickUnit.java,v 1.3.2.2 2005/10/25 20:37:34 mungady Exp $
    036     *
    037     * Changes (from 19-Dec-2001)
    038     * --------------------------
    039     * 19-Dec-2001 : Added standard header (DG);
    040     * 01-May-2002 : Changed the unit size from Number to double (DG);
    041     * 26-Sep-2002 : Fixed errors reported by Checkstyle (DG);
    042     * 08-Nov-2002 : Moved to new package com.jrefinery.chart.axis (DG);
    043     * 26-Mar-2003 : Implemented Serializable (DG);
    044     * 05-Sep-2005 : Implemented hashCode(), thanks to Thomas Morgner (DG);
    045     *
    046     */
    047
    048    package org.jfree.chart.axis;
    049
    050    import java.io.Serializable;
    051
    052    /**
    053     * Base class representing a tick unit.  This determines the spacing of the
    054     * tick marks on an axis.
    055     * <P>
    056     * This class (and any subclasses) should be immutable, the reason being that
    057     * ORDERED collections of tick units are maintained and if one instance can be
    058     * changed, it may destroy the order of the collection that it belongs to.
    059     * In addition, if the implementations are immutable, they can belong to
    060     * multiple collections.
    061     *
    062     * @see ValueAxis
    063     */
    064    public abstract class TickUnit implements Comparable, Serializable {
    065
    066        /** For serialization. */
    067        private static final long serialVersionUID = 510179855057013974L;
    068
    069        /** The size of the tick unit. */
    070        private double size;
    071
    072        /**
    073         * Constructs a new tick unit.
    074         *
    075         * @param size  the tick unit size.
    076         */
    077        public TickUnit(double size) {
    078            this.size = size;
    079        }
    080
    081        /**
    082         * Returns the size of the tick unit.
    083         *
    084         * @return The size of the tick unit.
    085         */
    086        public double getSize() {
    087            return this.size;
    088        }
    089
    090        /**
    091         * Converts the supplied value to a string.
    092         * <P>
    093         * Subclasses may implement special formatting by overriding this method.
    094         *
    095         * @param value  the data value.
    096         *
    097         * @return Value as string.
    098         */
    099        public String valueToString(double value) {
    100            return String.valueOf(value);
    101        }
    102
    103        /**
    104         * Compares this tick unit to an arbitrary object.
    105         *
    106         * @param object  the object to compare against.
    107         *
    108         * @return <code>1</code> if the size of the other object is less than this,
    109         *      <code>0</code> if both have the same size and <code>-1</code> this
    110         *      size is less than the others.
    111         */
    112        public int compareTo(Object object) {
    113
    114            if (object instanceof TickUnit) {
    115                TickUnit other = (TickUnit) object;
    116                if (this.size > other.getSize()) {
    117                    return 1;
    118                }
    119                else if (this.size < other.getSize()) {
    120                    return -1;
    121                }
    122                else {
    123                    return 0;
    124                }
    125            }
    126            else {
    127                return -1;
    128            }
    129
    130        }
    131
    132        /**
    133         * Tests this unit for equality with another object.
    134         *
    135         * @param obj  the object.
    136         *
    137         * @return <code>true</code> or <code>false</code>.
    138         */
    139        public boolean equals(Object obj) {
    140
    141            if (obj == null) {
    142                return false;
    143            }
    144            if (obj == this) {
    145                return true;
    146            }
    147            if (obj instanceof TickUnit) {
    148                TickUnit tu = (TickUnit) obj;
    149                return this.size == tu.size;
    150            }
    151            return false;
    152
    153        }
    154
    155        /**
    156         * Returns a hash code for this instance.
    157         *
    158         * @return A hash code.
    159         */
    160        public int hashCode() {
    161            final long temp = size != +0.0d ? Double.doubleToLongBits(size) : 0L;
    162            return (int) (temp ^ (temp >>> 32));
    163        }
    164
    165    }